uniform float Time;
uniform float WaveHeight;
uniform float WaveLength;
uniform float WaveSpeed;
varying float addition;

void main()
{
   gl_Position = ftransform();
   gl_TexCoord[0] = gl_Position;
   addition = ( sin( ( gl_Vertex.x / WaveLength ) + ( Time * WaveSpeed / 10000.0 ) ) ) +
            ( cos( ( gl_Vertex.z / WaveLength ) + ( Time * WaveSpeed / 10000.0 ) ) );
   gl_TexCoord[0].y += addition * WaveHeight;
}